import os
import json

from core import defaults


class Settings:

	def __init__(self):
		if os.path.isfile(defaults.MAIN_SETTINGS_FILE):
			settings_file = open(defaults.MAIN_SETTINGS_FILE, 'r')
			self._settings = json.load(settings_file)
			settings_file.close()
		else:
			self._settings = {}
		
	def save(self):
		settings_file = open(defaults.MAIN_SETTINGS_FILE, 'w')
		json.dump(self._settings, settings_file, indent=4, separators=(',', ': '))
		settings_file.close()

	def get(self, key):
		try:
			return self._settings[key]
		except KeyError:
			return None

	def set(self, key, value):
		self._settings[key] = value


settings = Settings()