from sqlalchemy import Column, Integer
from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy.ext.declarative import declared_attr

from core import defaults



class Model(object):

	@declared_attr
	def __tablename__(cls):
		try:
			modulelist = cls.__module__.split('.')

			i = 0 if modulelist[0] != defaults.MODULES else 1
			return modulelist[i].lower() + '_' + cls.__name__.lower()
		except AttributeError:
			return cls.__name__.lower()

	id = Column(Integer, primary_key=True)
	

Model = declarative_base(cls=Model)

