from twisted.web.server import Site
from twisted.web.resource import Resource
from twisted.internet import reactor

import json
import os

import db

from core.dispatcher import Dispatcher



LISTEN_PORT = 8080

# Pataca resource
class Pataca(Resource):
	isLeaf = True

	def render(self, request):
		urilist = request.uri.split('/')

		if urilist[-1] == '':
			del urilist[-1]

		return dispatcher.process(request, urilist[1:])


# Dispatcher
dispatcher = Dispatcher()
dispatcher.loadallmodules()

# Database setup
db.engine = db.createengine()
db.session = db.createsession(db.engine)
db.models.Model.metadata.bind = db.engine
#db.models.Model.metadata.create_all(db.engine)

# Twisted Site
root = Site(Pataca())

reactor.listenTCP(LISTEN_PORT, root)
print 'Listening on http://localhost:%d/' % LISTEN_PORT
reactor.run()
