import json
from cdecimal import Decimal
from datetime import datetime
from core import error


class Operation:

	def __init__(self, name=None, function=None):
		self.name = name
		self.function = function


def operation(name, function):
	return Operation(name, function)


class jsonserializer(json.JSONEncoder):

	def default(self, obj):
		if isinstance(obj, datetime.datetime):
			return int((obj - datetime(1970, 1, 1)).total_seconds())
		elif isinstance(obj, Decimal):
			return str(Decimal)
		return json.JSONEncoder.default(self, obj)

# jsonresponse
def jsonresponse(dict):
	return json.dumps(dict)


# decorator
def required_fields(*args):

	def wrapped(func):
		def verify(request, data, *args, **kwargs):


			not_present = []

			for field in fields:
				if field not in data:
					not_present.append(field)

			if len(not_present) > 0:
				return error(request, 'Fields not present: ' + ', '.join(not_present))

			return func(request, data, *args, **kwargs)

		return verify

	fields = args
	return wrapped